/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/******************************************************************************/
/* Nome: SEM_ABASTECIMENTO                                                    */
/*                                                                            */
/* Descrio:                                                                 */
/* Calcula datas de faturamento para um determinado mes baseando-se na        */
/* Periodicidade de faturamento e nos Feriados.                               */
/*                                                                            */
/* Criao:                                                                   */
/* 30/05/2003 - Gustavo Nosseis dos Santos                                    */
/******************************************************************************/
/* PARAMETROS:                                                                */
/*                                                                            */
/* P_CDFILIAL     - Cdigo da Filial                                          */
/* P_CDCLIENTE    - Cdigo do Cliente                                         */
/* P_CDPERIENTR   - Cdigo da Periodicidade de Entrega                        */
/* P_DTINICIAL    - Data do Inicio do Mes                                     */
/* P_IDDIANUTIL   - Considera dia nao util                                    */
/******************************************************************************/
/* @C:\WIN_PRJ\SQL\END_CONV\ORACLE\8691_VMNSTP_SEM_FATURAMENTO.SQL               */
/******************************************************************************/
CREATE OR REPLACE
PROCEDURE SEM_FATURAMENTO
  (P_CDFILIAL     IN VARCHAR2,
   P_CDCLIENTE    IN VARCHAR2,
   P_CDPERIENTR   IN VARCHAR2,
   P_DTINICIAL    IN DATE    ,
   P_IDDIANUTIL   IN VARCHAR2) IS
   V_CONTAUXI   NUMBER;
   V_DIENTREGA  VARCHAR2(2);
   V_DTDIAENTR  DATE;
   V_IDDIASEM   NUMBER;
   V_DTENTRAUX  DATE;
   V_PRIMVEZ    NUMBER;
   V_JAEXISTE   NUMBER;
/*  Cursor que contem as datas de faturamento no mes com base nos dias  */
/*  de faturamento semanais  */
   CURSOR C_DATAS_ENTR IS
(SELECT NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA))
        FROM DIASENTR
        WHERE
         CDPERIENTR = P_CDPERIENTR AND
         IDOCOR01 = '1'
UNION
        SELECT NEXT_DAY(
         NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA))
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            IDOCOR02 = '1' AND
           TO_CHAR(NEXT_DAY(
            NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA))
           ,TO_NUMBER(DIENTREGA)),'MM')
           = TO_CHAR(P_DTINICIAL,'MM')
UNION
        SELECT NEXT_DAY(
         NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA))
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            IDOCOR03 = '1' AND
           TO_CHAR(NEXT_DAY(
            NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),'MM')
           = TO_CHAR(P_DTINICIAL,'MM')
UNION
        SELECT NEXT_DAY(NEXT_DAY(
         NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA))
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            IDOCOR04 = '1' AND
           TO_CHAR(NEXT_DAY(NEXT_DAY(
            NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),'MM')
           = TO_CHAR(P_DTINICIAL,'MM')
UNION
        SELECT NEXT_DAY(LAST_DAY(P_DTINICIAL)-7,TO_NUMBER(DIENTREGA))
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            IDOCOR05 = '1' AND
           TO_CHAR(NEXT_DAY(LAST_DAY(P_DTINICIAL)-7,TO_NUMBER(DIENTREGA)),'MM')
           = TO_CHAR(P_DTINICIAL,'MM')
             ) ORDER BY 1;
/*  Cursor que contem as datas de faturamento do proximo mes
    com base nos dias de faturamento semanais  */
   CURSOR C_DATAS_PROX IS
(SELECT NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA))
        FROM DIASENTR
        WHERE
         CDPERIENTR = P_CDPERIENTR AND
         IDOCOR01 = '1'
UNION
        SELECT NEXT_DAY(
         NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA))
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            IDOCOR02 = '1' AND
           TO_CHAR(NEXT_DAY(
            NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA))
           ,TO_NUMBER(DIENTREGA)),'MM')
           = TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM')
UNION
        SELECT NEXT_DAY(
         NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA))
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            IDOCOR03 = '1' AND
           TO_CHAR(NEXT_DAY(
            NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),'MM')
           = TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM')
UNION
        SELECT NEXT_DAY(NEXT_DAY(
         NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA))
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            IDOCOR04 = '1' AND
           TO_CHAR(NEXT_DAY(NEXT_DAY(
            NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),'MM')
           = TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM')
UNION
        SELECT NEXT_DAY(LAST_DAY(LAST_DAY(P_DTINICIAL)+1)-7,TO_NUMBER(DIENTREGA))
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            IDOCOR05 = '1' AND
           TO_CHAR(NEXT_DAY(LAST_DAY(LAST_DAY(P_DTINICIAL)+1),TO_NUMBER(DIENTREGA)),'MM')
           = TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM')
           ) ORDER BY 1;
BEGIN
    V_DTENTRAUX := P_DTINICIAL;
    OPEN C_DATAS_ENTR;
    LOOP
      FETCH C_DATAS_ENTR
      INTO V_DTDIAENTR;
      EXIT WHEN C_DATAS_ENTR%NOTFOUND;

/*  calcula uma data de faturamento anterior a uma data nao util  */
     IF P_IDDIANUTIL = 'S' THEN
      V_CONTAUXI := 1;
       WHILE V_CONTAUXI > 0 LOOP
         SELECT COUNT(*) INTO V_CONTAUXI
         FROM FERIFILI
         WHERE
         CDFILIAL = P_CDFILIAL AND
         DTFERIFILI = V_DTDIAENTR;
         IF V_CONTAUXI > 0 THEN
            V_DTDIAENTR := V_DTDIAENTR - 1;
         END IF;
       END LOOP;
     END IF;

/*  Verifica se j existe a data de faturamento que foi calculada por um dia no util */     
SELECT COUNT(*) INTO V_JAEXISTE
     FROM CALEFATURVMN
     WHERE
       CDCLIENTE = P_CDCLIENTE AND
       CDFILIAL  = P_CDFILIAL  AND
       DTFATURVMN  = V_DTDIAENTR;
/*  Se j existir a data pula  */
     IF V_JAEXISTE = 0 THEN
/*  Verifica se ja existe alguma data de faturamento calculada para  */
/*  Incluir a data anterior ao proximo faturamento  */
         SELECT COUNT(*) INTO V_PRIMVEZ
         FROM CALEFATURVMN
         WHERE
         CDCLIENTE = P_CDCLIENTE AND
         CDFILIAL  = P_CDFILIAL  AND
         DTFATURVMN  = V_DTENTRAUX;
/*  Inclui a data de faturamento calculada no calendario de faturamento  */
         INSERT INTO CALEFATURVMN
           (CDCLIENTE, CDFILIAL,
            DTFATURVMN )
           VALUES
           (P_CDCLIENTE, P_CDFILIAL,
            V_DTDIAENTR );
         V_DTENTRAUX := V_DTDIAENTR;
     END IF;
    END LOOP;
    CLOSE C_DATAS_ENTR;
/*  Pega a primeira data anterior ao proximo faturamento  */
    OPEN C_DATAS_PROX;
    FETCH C_DATAS_PROX
    INTO V_DTENTRAUX;
    CLOSE C_DATAS_PROX;
    IF P_IDDIANUTIL = 'S' THEN
     V_CONTAUXI := 1;
      WHILE V_CONTAUXI > 0 LOOP
        SELECT COUNT(*) INTO V_CONTAUXI
        FROM FERIFILI
        WHERE
        CDFILIAL = P_CDFILIAL AND
        DTFERIFILI = V_DTENTRAUX;
        IF V_CONTAUXI > 0 THEN
           V_DTENTRAUX := V_DTENTRAUX - 1;
        END IF;
      END LOOP;
    END IF;
    V_DTENTRAUX := V_DTENTRAUX - 1;
/*  Verifica se ja existe a ultima data de faturamento que recebera  */
/*  a data anterior ao proximo faturamento  */
    SELECT COUNT(*) INTO V_PRIMVEZ
    FROM CALEFATURVMN
    WHERE
      CDCLIENTE = P_CDCLIENTE AND
      CDFILIAL  = P_CDFILIAL  AND
      DTFATURVMN  = V_DTDIAENTR;
END;
/

