/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_NIASSNUTRI                                               */
/* Tabela : NIASSNUTRI                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                           		         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_NIASSNUTRI'  and
            type = 'TR'                      and
            u.uid = o.uid                    and
            u.name = USER)
  DROP TRIGGER DTULTATU_NIASSNUTRI
  GO


CREATE TRIGGER DTULTATU_NIASSNUTRI
ON NIASSNUTRI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT'NIASSNUTRI', NULL, 'CDNIASNUTR='+CDNIASNUTR+';', GETDATE() FROM DELETED)

   END
   ELSE BEGIN
      UPDATE NIASSNUTRI
      SET DTULTATUNINU = GETDATE()
      FROM INSERTED
      WHERE
         (NIASSNUTRI.CDNIASNUTR = INSERTED.CDNIASNUTR)
   END;
END;
GO


