/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CEP                                               */
/* Tabela : CEP                                                               */
/*                                                                            */
/* Criao:                                                                   */
/* 09/04/2013 - Toms Prado Moura                                        */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CEP'   and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CEP
GO

CREATE TRIGGER DTULTATU_CEP
ON CEP
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CEP', null,'CDPAIS='+CDPAIS+';'+'NRCEP='+NRCEP+';',CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CEP
      SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(CEP.CDPAIS ,0) = ISNULL(INSERTED.CDPAIS ,0)) AND
            (ISNULL(CEP.NRCEP ,0) = ISNULL(INSERTED.NRCEP ,0));

   END;
END;
GO

UPDATE CEP SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATU IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUCEP' and
            type = 'D')
   ALTER TABLE CEP DROP CONSTRAINT DEFAULT_DTULTATUCEP
GO

ALTER TABLE CEP ADD CONSTRAINT DEFAULT_DTULTATUCEP
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATU
GO

